"""
A diet exclusive of all animal products.

https://schema.org/VeganDiet
"""

from datetime import *
from copy import deepcopy
from typing import *
from time import *

from typing_extensions import TypedDict, NotRequired
from pydantic import *


from schorg.schema_org_obj import SchemaOrgObj, SchemaOrgBase


class VeganDietInheritedProperties(TypedDict):
    """A diet exclusive of all animal products.

    References:
        https://schema.org/VeganDiet
    Note:
        Model Depth 5
    Attributes:
    """


class VeganDietProperties(TypedDict):
    """A diet exclusive of all animal products.

    References:
        https://schema.org/VeganDiet
    Note:
        Model Depth 5
    Attributes:
    """


class VeganDietAllProperties(
    VeganDietInheritedProperties, VeganDietProperties, TypedDict
):
    pass


class VeganDietBaseModel(SchemaOrgBase):
    id_: Optional[Any] = Field(default="VeganDiet", alias="@id")
    context_: Optional[Any] = Field(default=None, alias="@context")
    graph_: Optional[Any] = Field(default=None, alias="@graph")

    class Config:
        ...


def create_schema_org_model(
    type_: Union[
        VeganDietProperties, VeganDietInheritedProperties, VeganDietAllProperties
    ] = VeganDietAllProperties
) -> Type[SchemaOrgBase]:
    model = create_model_from_typeddict(type_, __base__=SchemaOrgBase)
    model.__name__ = "VeganDiet"
    return model


VeganDiet = create_schema_org_model()


def create_vegandiet_model(
    model: Union[
        VeganDietProperties, VeganDietInheritedProperties, VeganDietAllProperties
    ]
):
    _type = deepcopy(VeganDietAllProperties)
    for k in model.__annotations__.keys():
        if k not in _type.__annotations__:
            raise TypeError(f"{k} not part of VeganDietAllProperties")
    delete_keys = []
    for k in _type.__annotations__.keys():
        if k not in model.__annotations__:
            delete_keys.append(k)
    for k in delete_keys:
        del _type.__annotations__[k]
    return create_schema_org_model(type_=_type)


def schema_json(model: VeganDietAllProperties):
    pydantic_type = create_vegandiet_model(model=model)
    return pydantic_type(model).schema_json()
